<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="100px">
      <el-form-item label="损伤区域" prop="damageArea">
        <el-input
          v-model="queryParams.damageArea"
          placeholder="请输入损伤区域"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="探测距离" prop="detectDistance">
        <el-input
          v-model="queryParams.detectDistance"
          placeholder="请输入探测距离"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="探测方位角" prop="detectAngle">
        <el-input
          v-model="queryParams.detectAngle"
          placeholder="请输入探测方位角"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="红外波段" prop="infraredBand">
        <el-input
          v-model="queryParams.infraredBand"
          placeholder="请输入红外波段"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['data:infraredIn:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['data:infraredIn:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['data:infraredIn:remove']"
        >删除</el-button>
      </el-col>
      <!-- <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['data:infraredIn:export']"
        >导出</el-button>
      </el-col> -->
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="infraredInList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="编号" align="center" prop="id" />
      <el-table-column label="完好发射率" align="center" prop="fullLaunchRate"/>
      <el-table-column label="损伤发射率" align="center" prop="damageLaunchRate" />
      <el-table-column label="损伤区域" align="center" prop="damageArea" />
      <el-table-column label="损伤面积比" align="center" prop="damageAreaRatio" />
      <el-table-column label="表面状态说明" align="center" prop="surfaceDescription" />
      <el-table-column label="探测距离" align="center" prop="detectDistance" />
      <el-table-column label="探测方位角" align="center" prop="detectAngle" />
      <el-table-column label="红外波段" align="center" prop="infraredBand" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['data:infraredIn:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['data:infraredIn:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改红外输入对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="110px">
        <el-form-item label="完好发射率" prop="fullLaunchRate">
          <el-input v-model="form.fullLaunchRate" placeholder="请输入完好发射率" :controls="false" precision="6" />
        </el-form-item>
        <el-form-item label="损伤发射率" prop="damageLaunchRate">
          <el-input v-model="form.damageLaunchRate" placeholder="请输入损伤发射率" :controls="false" precision="6" />
        </el-form-item>
        <el-form-item label="损伤区域" prop="damageArea">
          <el-input v-model="form.damageArea" placeholder="请输入损伤区域" :controls="false" precision="6" />
        </el-form-item>
        <el-form-item label="损伤面积比" prop="damageAreaRatio">
          <el-input v-model="form.damageAreaRatio" placeholder="请输入损伤面积比" :controls="false" precision="6" />
        </el-form-item>
        <el-form-item label="表面状态说明" prop="surfaceDescription">
          <el-input v-model="form.surfaceDescription" placeholder="请输入表面状态说明" :controls="false" precision="6" />
        </el-form-item>
        <el-form-item label="探测距离" prop="detectDistance">
          <el-input v-model="form.detectDistance" placeholder="请输入探测距离" :controls="false" precision="6" />
        </el-form-item>
        <el-form-item label="探测方位角" prop="detectAngle">
          <el-input v-model="form.detectAngle" placeholder="请输入探测方位角" :controls="false" precision="6" />
        </el-form-item>
        <el-form-item label="红外波段" prop="infraredBand">
          <el-input v-model="form.infraredBand" placeholder="请输入红外波段" :controls="false" precision="6" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listInfraredIn, getInfraredIn, delInfraredIn, addInfraredIn, updateInfraredIn } from "@/api/data/infraredIn";

export default {
  name: "InfraredIn",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 红外输入表格数据
      infraredInList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        damageArea: null,
        detectDistance: null,
        detectAngle: null,
        infraredBand: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        flowFieldOutputPath: [
          { required: true, message: "流场输出结果不能为空", trigger: "change" }
        ],
      },
      fileType: ['cas', 'dat']
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询红外输入列表 */
    getList() {
      this.loading = true;
      listInfraredIn(this.queryParams).then(response => {
        this.infraredInList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        fullLaunchRate: null,
        damageLaunchRate: null,
        damageArea: null,
        damageAreaRatio: null,
        surfaceDescription: null,
        detectDistance: null,
        detectAngle: null,
        infraredBand:null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加红外输入";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getInfraredIn(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改红外输入";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateInfraredIn(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addInfraredIn(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除红外输入编号为"' + ids + '"的数据项？').then(function() {
        return delInfraredIn(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('data/infraredIn/export', {
        ...this.queryParams
      }, `infraredIn_${new Date().getTime()}.xlsx`)
    },
    getFileName(path) {
      if (!path) {
        return ''
      } else if (path.lastIndexOf("/") > -1) {
        const newName = path.slice(path.lastIndexOf("/") + 1)
        const names = newName.split(".")
        if ((names.size = 2) && (names[0].length > 19)) {
          return newName.substring(0, names[0].length - 19) + '.' + names[1]
        } else {
          return newName
        }
      } else {
        return '';
      }
    },
    download(path) {
      this.$download.resource(path);
    }
  }
};
</script>
